/**/


/* scrlib.c functions for editing and screen control                   */
/* Copyright 1991 David R. Gregoire  all rights reserved               */


#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>              /* contains prototype for getche()  used to
                                 * read choice */
#include <bios.h >              /* contains necessary function prototypes for
                                 * clrscrn() */
/* and poscurs() functions                             */
#include "scrlib.h"              /* prototypes for functions */


/************************************************************/
/* edt_str() starting at rd_row, rd_col  displays rd_dig characters of string */
/* pointed to by ed_str. If string is longer than rd_dig  it will be truncated */
/* to  rd_dig characters, other than that no checking is done. The string to */
/* be edited must be initialized before editing and must not exceed 80 */
/* characters . ed_str() /* allows editing with normal editing keys , ins, */
/* del, backspace,arrows */
/***********************************************************/

void
edt_str(int rd_row, int rd_col, int rd_dig, char *ed_str, int *ins)
{
        /* start of edt_str  */


        int far        *scrp;

        int             char_count = 0; /* character counter */
        char            in_char[81];
        int             mov_count;      /* counter for shift moves */
        int             loop_count;
        char            read_char;
        char            read_ext;
        int             ins_on;

        ins_on = *ins;


        scrp = (int far *) VID_START;
        ed_str[rd_dig] = '\0';  /* make sure string is not over length */
        strcpy(in_char, ed_str);


        dir_str(rd_row, rd_col, in_char);

        if (ins_on == 0)
        {
                /*
                 * change to display 'ins' at another screen position
                 */
                poscurs(24, 40);
                printf("ovr");
        }

/**/


/* scrlib.c functions for editing and screen control                   */
/* Copyright 1991 David R. Gregoire  all rights reserved               */


        if (ins_on == 1)
        {
                /*
                 * change to display 'ovr' at another screen position
                 */
                poscurs(24, 40);
                printf("ins");

        }
        for (loop_count = 0; loop_count < 756; loop_count++)
        {
                poscurs(rd_row, (char_count + rd_col));
                read_char = getch();
                if (read_char == 9)
                {               /* tab key */
                        if (char_count < rd_dig - 7)
                                char_count += 7;
                        else
                                char_count = rd_dig - 1;
                }
                if (read_char == 0)
                {               /* read second character if extended key code */
                        read_ext = getch();
                        if (read_ext == 82)
                        {
                                if (ins_on == 0)
                                {
                                        ins_on = 1;
                                        /*
                                         * change to display 'ins' at another
                                         * screen position
                                         */
                                        poscurs(24, 40);
                                        printf("ins");
                                } else
                                {
                                        ins_on = 0;
                                        /*
                                         * change to display 'ovr' at another
                                         * screen position
                                         */
                                        poscurs(24, 40);
                                        printf("ovr");

                                }


                        }

/**/


/* scrlib.c functions for editing and screen control                   */
/* Copyright 1991 David R. Gregoire  all rights reserved               */


                        if ((read_ext == 75) && (char_count >= 1))
                        {       /* left arrow */
                                char_count--;
                        }
                        if ((read_ext == 77) && (char_count < (rd_dig - 1)))
                        {       /* right arrow */
                                char_count++;
                        }
                        if (read_ext == 71)
                        {       /* home */
                                char_count = 0;
                        }
                        if (read_ext == 79)
                        {       /* end */
                                char_count = (rd_dig - 1);
                        }
                        if (read_ext == 83)
                        {       /* del */

                                if (char_count < (rd_dig - 1))
                                {
                                        for (mov_count = char_count; mov_count < (rd_dig - 1); mov_count++)
                                        {
                                                in_char[mov_count] = in_char[mov_count + 1];
                                        }
                                }
                                in_char[rd_dig - 1] = ' ';


                                dir_str(rd_row, rd_col, in_char);
                                poscurs(rd_row, (char_count + rd_col)); /* adjust cursor */


                        }
                }
                if ((read_char >= ' ') && (read_char <= '~'))
                {

                        if (ins_on)
                        {       /* if insert on shift string */
                                for (mov_count = rd_dig - 1; mov_count > char_count; mov_count--)
                                {
                                        in_char[mov_count] = in_char[mov_count - 1];
                                }

                                dir_str(rd_row, rd_col, in_char);

                                poscurs(rd_row, (char_count + rd_col)); /* adjust cursor */
                        }
                        putchar(read_char);
                        in_char[char_count] = read_char;
                        poscurs(22, 12);
                        if (char_count < (rd_dig - 1))
                                char_count++;

/**/


/* scrlib.c functions for editing and screen control                   */
/* Copyright 1991 David R. Gregoire  all rights reserved               */


                } else if (read_char == 13)
                {
                        in_char[rd_dig] = '\0';
                        break;
                }


                        if(read_char == 27) /* escape key return spaces */
                        {
                        init_str(SPACE,in_char,rd_dig);
                        break;
                        }
                if (loop_count == 755)
                        in_char[rd_dig] = '\0';

                if ((read_char == 8) && (char_count >= 1))
                {
                        poscurs(rd_row, (char_count + rd_col));
                        putchar(' ');
                        in_char[char_count] = ' ';
                        char_count--;
                }
        }



        strcpy(ed_str, in_char);
        /* end of edt_str   */
        *ins = ins_on;

        poscurs(24, 40);
        printf("   ");
}


/************************************************************/
/* edt_cod() is used for editing a code string at rd_row, rd_col on the screen */
/* the string must be initialized before editing. This function first assures */
/* that the string is only rd_dig long. It is validated against a string    */
/* pointed to  by val_str. Validation is simply a substring comparison i.e. */
/* the string is  valid if it is part of the validation string . The */
/* validation string is hard coded to  display  starting at 23,2, messages */
/* display at the end of the validation string */
/************************************************************/
void
edt_cod(int rd_row, int rd_col, int rd_dig, char *ed_str, char *val_str, int *ins)
{
        int far        *scrp;


/**/


/* scrlib.c functions for editing and screen control                   */
/* Copyright 1991 David R. Gregoire  all rights reserved               */


        int             val_code = 1;
        int             char_count = 0; /* character counter */
        char            in_char[80];
        int             mov_count;      /* counter for shift moves */
        int             loop_count;
        char            read_char;
        char            read_ext;
        int             ins_on;

        ins_on = *ins;

        scrp = (int far *) VID_START;

        ed_str[rd_dig] = '\0';  /* make sure string is not over length */
        strcpy(in_char, ed_str);

        dir_str(rd_row, rd_col, in_char);
        dir_str(23, 2, val_str);

        if (ins_on == 0)
        {
                /*
                 * change to display 'ins' at another screen position
                 */
                poscurs(24, 40);
                printf("ovr");
        }
        if (ins_on == 1)
        {
                /*
                 * change to display 'ovr' at another screen position
                 */
                poscurs(24, 40);
                printf("ins");

        }
        while (val_code)
        {                       /* while val code = 1 do not return */
                for (loop_count = 0; loop_count < 756; loop_count++)
                {
                        poscurs(rd_row, (char_count + rd_col));
                        read_char = getch();
                        if (read_char == 9)
                        {       /* tab key */
                                if (char_count < rd_dig - 7)
                                        char_count += 7;
                                else
                                        char_count = rd_dig - 1;
                        }
                        if (read_char == 0)
                        {       /* read second character if extended key code */
                                read_ext = getch();
                                if (read_ext == 82)
                                {
                                        if (ins_on == 0)
                                        {
                                                ins_on = 1;
                                                poscurs(24, 40);
                                                printf("ins");
                                        } else
/**/


/* scrlib.c functions for editing and screen control                   */
/* Copyright 1991 David R. Gregoire  all rights reserved               */


                                        {
                                                ins_on = 0;
                                                poscurs(24, 40);
                                                printf("ovr");

                                        }


                                }
                                if ((read_ext == 75) && (char_count >= 1))
                                {       /* left arrow */
                                        char_count--;
                                }
                                if ((read_ext == 77) && (char_count < (rd_dig - 1)))
                                {       /* right arrow */
                                        char_count++;
                                }
                                if (read_ext == 71)
                                {       /* home */
                                        char_count = 0;
                                }
                                if (read_ext == 79)
                                {       /* end */
                                        char_count = (rd_dig - 1);
                                }
                                if (read_ext == 83)
                                {       /* del */

                                        if (char_count < (rd_dig - 1))
                                        {
                                                for (mov_count = char_count; mov_count < (rd_dig - 1); mov_count++)
                                                {
                                                        in_char[mov_count] = in_char[mov_count + 1];
                                                }
                                        }
                                        in_char[rd_dig - 1] = ' ';
                                        dir_str(rd_row, rd_col, in_char);
                                        poscurs(rd_row, (char_count + rd_col)); /* adjust cursor */


                                }
                        }
                        if ((read_char >= ' ') && (read_char <= '~'))
                        {

                                if (ins_on)
                                {       /* if insert on shift string */
                                        for (mov_count = rd_dig - 1; mov_count > char_count; mov_count--)
                                        {
                                                in_char[mov_count] = in_char[mov_count - 1];
                                        }

/**/


/* scrlib.c functions for editing and screen control                   */
/* Copyright 1991 David R. Gregoire  all rights reserved               */



                                        dir_str(rd_row, rd_col, in_char);

                                        poscurs(rd_row, (char_count + rd_col)); /* adjust cursor */

                                }
                                read_char = ((char) (toupper(read_char)));
                                putchar(read_char);
                                in_char[char_count] = read_char;
                                if (char_count < (rd_dig - 1))
                                        char_count++;

                        } else if (read_char == 13)
                        {
                                in_char[rd_dig] = '\0';
                                break;
                        }

                        if(read_char == 27) /* escape key return spaces */
                        {
                        val_code = 0; /* set loop terminator */
                        init_str(SPACE,in_char,rd_dig);
                        break;
                        }
                        if (loop_count == 755)
                                in_char[rd_dig] = '\0';

                        if ((read_char == 8) && (char_count >= 1))
                        {
                                poscurs(rd_row, (char_count + rd_col));
                                putchar(' ');
                                in_char[char_count] = ' ';
                                char_count--;
                        }
                }

                poscurs(23, (3 + strlen(val_str)));
                if ((strstr(val_str, in_char)) || (val_code ==0))
                {               /* if str is in validation list */

                        val_code = 0;   /* set loop terminator  */
                        printf("           ");
                } else
                        printf("**INVALID**");

        }                       /* end of validation loop  */

        strcpy(ed_str, in_char);
        poscurs(23, 2);
        printf("                                                                             ");
        /* end of edt_cod   */

/**/


/* scrlib.c functions for editing and screen control                   */
/* Copyright 1991 David R. Gregoire  all rights reserved               */


        *ins = ins_on;
        poscurs(24, 40);
        printf("   ");
}


/************************************************************/
/* edt_date() edits a date in the format mm/dd/yy. the date must be contained */
/* in  a string pointed to by ed_str. Editing is done  at rd_row, rd_col */
/* Minimal validation is done to make sure some sort of reasonable date is */
/* returned, currently years between  70 and 95 are hard coded in the */
/* validation */
/************************************************************/

void
edt_date(int rd_row, int rd_col, char *date_str)
{
        /* start of read number  */

        int             char_count = 0; /* character counter */
        char            in_char[20];
        int             loop_count;
        int             rd_dig = 8;     /* read digit always 8 for dates */
        char            read_char;
        char            read_ext;       /* read variable for extended key codes */
        int             chk_val;/* check value */
        char            chk_str[3];

        int             val_date = 1;   /* zero indicates valid date */
        int             vald1;
        int             vald2;
        int             vald3;
        int             ret_space = 0;

        chk_str[2] = '\0';      /* string terminator for check string */
        date_str[rd_dig] = '\0';/* make sure string is not over length */
        strcpy(in_char, date_str);
        poscurs(rd_row, rd_col);
        printf(in_char);

        while (val_date)
        {


                for (loop_count = 0; loop_count < 80; loop_count++)
                {


                        poscurs(rd_row, (char_count + rd_col));
                        read_char = getch();

/**/


/* scrlib.c functions for editing and screen control                   */
/* Copyright 1991 David R. Gregoire  all rights reserved               */


                        if (read_char == 0)
                        {       /* read second character if extended key code */
                                read_ext = getch();

                                if ((read_ext == 75) && (char_count >= 1))
                                {       /* left arrow */
                                        char_count--;

                                        if (in_char[char_count] == '/') /* check for slash */
                                                char_count--;
                                }
                                if ((read_ext == 77) && (char_count < (rd_dig - 1)))
                                {       /* right arrow */
                                        char_count++;
                                        if (in_char[char_count] == '/') /* check for slash */
                                                char_count++;
                                }

                                if (read_ext == 71)
                                {       /* home */
                                        char_count = 0;
                                }
                                if (read_ext == 79)
                                {       /* end */
                                        char_count = (rd_dig - 1);
                                }
                        }
                        if ((read_char >= '0') && (read_char <= '9'))
                        {
                                if (in_char[char_count] == '/')
                                {       /* check for slash adjust curssor */
                                        char_count++;
                                        poscurs(rd_row, (char_count + rd_col));

                                }
                                putchar(read_char);
                                in_char[char_count] = read_char;
                                if (char_count < (rd_dig - 1))
                                char_count++;
                        } else if ((read_char == 13) || (loop_count == 79))
                        {
                                in_char[rd_dig] = '\0';
                                break;
                        }
                        if ((read_char == 8) && (char_count >= 1))
                        {
                                if (in_char[char_count] == '/') /* check for slash */
                                        char_count--;
                                poscurs(rd_row, (char_count + rd_col));
                                putchar(' ');
                                char_count--;
                        }

/**/


/* scrlib.c functions for editing and screen control                   */
/* Copyright 1991 David R. Gregoire  all rights reserved               */


                        if(read_char == 27) /* escape key return spaces */
                        {
                        val_date = 0; /* set loop terminator */
                        init_str(SPACE,in_char,rd_dig);
                        ret_space = 1;
                        break;
                        }
                }
                chk_str[0] = in_char[0];        /* check day 0-31 */
                chk_str[1] = in_char[1];
                chk_val = atoi(chk_str);
                if ((chk_val > 0) && (chk_val < 13))
                        vald1 = 0;
                else
                        vald1 = 1;

                chk_str[0] = in_char[3];        /* check month  */
                chk_str[1] = in_char[4];
                chk_val = atoi(chk_str);
                if ((chk_val > 0) && (chk_val < 32))
                        vald2 = 0;
                else
                        vald2 = 1;

                chk_str[0] = in_char[6];        /* check year  */
                chk_str[1] = in_char[7];
                chk_val = atoi(chk_str);
                /*
                 * change the values in the following if test if you want to
                 * accept years in a range
                 */
                /* other than between 70 and 95 */
                if ((chk_val > 70) && (chk_val < 95))
                        vald3 = 0;
                else
                        vald3 = 1;

                poscurs(rd_row, (rd_col + rd_dig));
                /* set val date only if all 3 values are valid */
                /* or if escape used and spaces to be returned */
                if ((((vald1 == 0) && (vald2 == 0) && (vald3 == 0))) || (ret_space == 1))
                        val_date = 0;
                else
                        val_date = 1;

                if (val_date == 0)
                        putchar(' ');
                else
                        putchar('*');


        }                       /* end  of main loop after validation */
        strcpy(date_str, in_char);

        /* end of edt_date   */
}

/**/


/* scrlib.c functions for editing and screen control                   */
/* Copyright 1991 David R. Gregoire  all rights reserved               */


/*********************************************************************/
/* rd_yes_no() allows yes no choice to be read starting at rd_row,rd_col */
/* the function will only return if y or n (upper or lower case) is entered */
/* returns int containing lower case 'y' or 'n'
/*********************************************************************/
int
rd_yes_no(int rd_row, int rd_col)
{
        int             choice;

        do
        {                       /* loop to read in and check choice */
                poscurs(rd_row, rd_col);
                printf("enter choice y or n --> ");     /* prompt choice */
                poscurs(rd_row, (rd_col + 25));
                choice = getche();      /* wait for key to be pressed */

                choice = tolower(choice);       /* converts choice to lower
                                                 * case if entered */
                /* as upper case function automatically checks */
                /* if argument is upper case , if already lower */
                /* it is returned unchanged */
        }
        while ((choice != 'n') && (choice != 'y'));     /* check for valid
                                                         * choice */

        return (choice);
}
/************************************************************************/
/* init_str()  is used to initialize num_char characters of a string pointed*/
/* to by dest_str to init_char */
/************************************************************************/


void
init_str(char init_char, char *dest_str, int num_char)
{
        int             ctr;

        for (ctr = 0; ctr < num_char; ctr++)
        {
                dest_str[ctr] = init_char;      /* move characters */
        }
        dest_str[ctr] = '\0';   /* string terminator */

}

/**/


/* scrlib.c functions for editing and screen control                   */
/* Copyright 1991 David R. Gregoire  all rights reserved               */


/************************************************************************/
/* val_win()  is used to to enter a code num_val characters long */
/* strings pointed to by val_pt[] an array of pointers to char */
/* are used as a picklist for values to be returned. the first num_val */
/* characters of the chosen string are returned in the string pointed to */
/* by val_str the picklist appears in a 'pop-up' window defined from */
/* the screen is saved and restored from an array of int [ROMAX][COMAX] */
/* ulr,ulc,to lrr,lrc , the screen is restored at the end of the function */
/*This function is included here primarily as an illustration of use of some*/
/* of the other scrlib functions. */
/************************************************************************/

void
val_win(int ulr, int ulc, int lrr, int lrc, int num_val, char *val_pt[], int *sav, char *val_str )
{
        int             wait;
        int             dis_ln;
        int             count = 0;
        int             pos_count;
        int             col_pos = 0;
        int             choice;
        char            choice_str[80];
        int             num_lines = 0;
        int             not_ed = 1;
        static char     d_num[][5] = {"[ 0]", "[ 1]", "[ 2]", "[ 3]", "[ 4]", "[ 5]", "[ 6]", "[ 7]", "[ 8]", " 9", "10", "11", "12",
        "[13]", "[14]", "[15]", "[16]", "[17]", "[18]", "[19]", "[20]", "[21]", "[22]"};
        char           *pt;

        wi_sav(ulr, ulc, lrr, lrc, sav);
        clear_box(ulr, ulc, lrr, lrc);
        draw_box(ulr, ulc, lrr, lrc);
        draw_box(ulr + 2, ulc + 1, lrr - 1, lrc - 1);
        dis_ln = ulr + 2;
        pos_count = 0;
        while (val_pt[pos_count])       /* count display lines */
                pos_count++;
        dis_ln = ((lrr - dis_ln - pos_count) / 2) + dis_ln;
        pt = val_pt[0];
        while (*pt)
        {
                col_pos++;
                pt++;
        }
        col_pos = ((lrc - ulc - col_pos) / 2) + ulc + 5;        /* offset for center */


        while (val_pt[count])
        {
                pt = (val_pt[count]);
                dir_str(dis_ln, col_pos - 6, d_num[count]);
                dir_str(dis_ln, col_pos, (val_pt[count]));
                dis_ln++;
                count++;
                num_lines++;
        }
/**/


/* scrlib.c functions for editing and screen control                   */
/* Copyright 1991 David R. Gregoire  all rights reserved               */


        num_lines--;
        /* while ((wait = getkey()) == EOF);  *//* wait for keypress */
        col_pos = ((lrc - ulc - 20) / 2) + ulc; /* offset for center */
        dir_str(lrr - 2, col_pos, "ENTER CHOICE");
        choice = -1;
        col_pos = ((lrc - ulc - 20) / 2) + ulc; /* offset for center */
        while (((choice < 0) || (choice > num_lines)) || (not_ed))
        {
                choice = read_int(lrr - 2, col_pos + 16, 3);
                dir_str(lrr - 2, col_pos + 16, "    ");
                not_ed = 0;
                if (choice == 99)
                        break;

        }

        sub_str(0, num_val, val_pt[choice], val_str);
        wi_rst(ulr, ulc, lrr, lrc, sav);



}

/************************************************************************/
/* wi_sav()  is used to save a rectangular region of the screen  to an    */
/* array of int, sav[ROMAX][COMAX], */
/************************************************************************/
void
wi_sav(int ulr, int ulc, int lrr, int lrc, int sav[][COMAX])
{
        int             count;
        int             count1;

        int far        *scrp;


        scrp = (int far *) VID_START;

        for (count1 = (ulr); count1 < lrr + 1; count1++)
        {
                for (count = (ulc); count < lrc + 1; count++)
                {
                        *(*(sav + count1) + count) = *(scrp + count1 * COMAX + count);
                }
        }

}


/**/


/* scrlib.c functions for editing and screen control                   */
/* Copyright 1991 David R. Gregoire  all rights reserved               */


/************************************************************************/
/* wi_rst()  is used to restore a rectangular region of the screen from  an */
/* array of int, sav[ROMAX][COMAX],This function is the inverse of  */
/* wi_sav(), it assumes that part of the screen was previously saved */
/* by wi_sav(), no checking is done on the array */
/************************************************************************/
void
wi_rst(int ulr, int ulc, int lrr, int lrc, int sav[][COMAX])
{
        int             count;
        int             count1;
        int far        *scrp;


        scrp = (int far *) VID_START;

        for (count1 = (ulr); count1 < lrr + 1; count1++)
        {
                for (count = (ulc); count < lrc + 1; count++)
                {
                        *(scrp + count1 * COMAX + count) = *(*(sav + count1) + count);
                }
        }

}

/************************************************************************/
/* wi_sav1()  is used to save a rectangular region of the screen  to an    */
/* array of int, the only difference between this function and wi_sav() */
/* is that this function uses a single dimension array */
/************************************************************************/
void
wi_sav1(int ulr, int ulc, int lrr, int lrc, int *sav)
{
        int             count;
        int             count1;

        int far        *scrp;


        scrp = (int far *) VID_START;

        for (count1 = (ulr); count1 < lrr + 1; count1++)
        {
                for (count = (ulc); count < lrc + 1; count++)
                {
                        *(sav + count1 * COMAX + count) = *(scrp + count1 * COMAX + count);
                }
        }

}



/**/


/* scrlib.c functions for editing and screen control                   */
/* Copyright 1991 David R. Gregoire  all rights reserved               */


/***************************************************************/
/* clear_box() clears a box on the screen from ulr (upper left row) */
/* ulc (upper left column) to lrr (lower right row) ,lrc (lower right column) */
/* the box is cleared by filling it with spaces. This function can be used to */
/* fill  any area of the screen with spaces it can be used to clear part of a */
/* single  line                                                           */
/******************************************************************/

void
clear_box(int ulr, int ulc, int lrr, int lrc)
{
        int far        *scrp;

        /* start of clear box    */
        register int    count = 0;      /* count iterations                   */
        register int    count1 = 0;     /* count iterations                   */

        scrp = (int far *) VID_START;

        for (count1 = (ulr); count1 < lrr + 1; count1++)
        {
                for (count = (ulc); count < lrc + 1; count++)
                {
                        *(scrp + count1 * COMAX + count) = ' ' | ATT_NOR;
                }
        }

        /* end of clear box   */

}

/******************************************************************/
/* draw_box() draws a single line box on the screen from ulr (upper left row) */
/* ulc (upper left column) to lrr (lower right row) ,lrc (lower right column) */
/******************************************************************/
void
draw_box(int ulr, int ulc, int lrr, int lrc)
{
        int far        *scrp;


        int             count;  /* count iterations                   */

        scrp = (int far *) VID_START;

        /* start of draw box    */
        for (count = (ulc + 1); count < lrc; count++)
        {
                *(scrp + ulr * COMAX + count) = 196 | ATT_NOR;
        }

        *(scrp + ulr * COMAX + ulc) = 218 | ATT_NOR;

        for (count = (ulr + 1); count < lrr; count++)
        {

                *(scrp + count * COMAX + ulc) = 179 | ATT_NOR;
        }

/**/


/* scrlib.c functions for editing and screen control                   */
/* Copyright 1991 David R. Gregoire  all rights reserved               */


        *(scrp + lrr * COMAX + ulc) = 192 | ATT_NOR;

        for (count = (ulc + 1); count < lrc; count++)
        {
                *(scrp + lrr * COMAX + count) = 196 | ATT_NOR;
        }

        *(scrp + lrr * COMAX + lrc) = 217 | ATT_NOR;
        for (count = (lrr - 1); count > ulr; count--)
        {

                *(scrp + count * COMAX + lrc) = 179 | ATT_NOR;
        }
        *(scrp + ulr * COMAX + lrc) = 191 | ATT_NOR;
        /* end of draw box   */
}





/*************************************************************/
/* edt_num() edits a string to be returned  containing only digits, spaces */
/* '.', and '-', suitable for conversion to a numeric value. The string must */
/* be initialized before the function is called .Using the escape key returns */
/*all zeroes*/
/* The string is edited at rd_row,rd_col. The string is rd_dig long with */
/* rd_dec decimal places */
/*************************************************************/
void
edt_num(int rd_row, int rd_col, int rd_dig, int rd_dec, char *ed_num)
{
        /* start of read number  */
        int             count;
        int             char_count = 0; /* character counter */
        char            in_char[20];
        int             loop_count;
        char            read_char;
        int             minus_sg = 0;
        char            read_ext;
        int             sp_st = 0;
        int             val_code = 1;

        ed_num[rd_dig] = '\0';  /* make sure string is not over length */
        if (rd_dec != 0)
        {
                if (ed_num[rd_dig - 1 - rd_dec] != '.')
                        ed_num[rd_dig - 1 - rd_dec] = '.';
        }
/**/


/* scrlib.c functions for editing and screen control                   */
/* Copyright 1991 David R. Gregoire  all rights reserved               */


        strcpy(in_char, ed_num);
        poscurs(rd_row, rd_col);
        printf(in_char);
        while (val_code)
        {                       /* while valid = 1 do not return */
                for (loop_count = 0; loop_count < 80; loop_count++)
                {


                        if (char_count == 0)
                        {       /* reset allow minus sign if backspaced to 0 */
                                minus_sg = 0;
                                sp_st = 0;
                        }
                        poscurs(rd_row, (char_count + rd_col));

                        if (in_char[char_count] == '.')
                        {
                                char_count++;
                                poscurs(rd_row, (char_count + rd_col));
                        }
                        read_char = getch();

                        if (read_char == 0)
                        {       /* read second character if extended key code */
                                read_ext = getch();

                                if ((read_ext == 75) && (char_count >= 1))
                                {       /* left arrow */
                                        char_count--;

                                        if (in_char[char_count] == '.') /* check for slash */
                                                char_count--;
                                }
                                if ((read_ext == 77) && (char_count < (rd_dig - 1)))
                                {       /* right arrow */
                                        char_count++;
                                        if (in_char[char_count] == '.') /* check for slash */
                                                char_count++;
                                }
                                if (read_ext == 71)
                                {       /* home */
                                        char_count = 0;
                                }
                                if (read_ext == 79)
                                {       /* end */
                                        char_count = (rd_dig - 1);
                                }
                        }
                        if (((read_char >= '0') && (read_char <= '9')) ||
                            ((char_count < (rd_dig - 1 - rd_dec)) && ((read_char == ' ') && (sp_st == 0))) ||
                            ((char_count < (rd_dig - 1 - rd_dec)) && ((read_char == '-') && (minus_sg == 0)))
                                )
/**/


/* scrlib.c functions for editing and screen control                   */
/* Copyright 1991 David R. Gregoire  all rights reserved               */



                        {
                                if (in_char[char_count] == '.')
                                {
                                        char_count++;
                                        poscurs(rd_row, (char_count + rd_col));
                                }
                                putchar(read_char);
                                in_char[char_count] = read_char;
                                if (char_count < (rd_dig - 1))
                                        char_count++;
                                if (read_char != ' ')
                                {
                                        sp_st = 1;      /* allow spaces only in
                                                         * first positions */
                                        minus_sg = 1;
                                }
                        } else if (read_char == 13)
                        {
                                in_char[rd_dig] = '\0';
                                break;
                        }

                        if(read_char == 27) /* escape key return ZEROS */
                        {
                        val_code = 0; /* set loop terminator */
                        init_str(ZERO,in_char,rd_dig);
                         /* replace decimal point if needed */
                           if (rd_dec != 0)
                           {
                             in_char[rd_dig - 1 - rd_dec] = '.';
                           }
                        break;
                        }
                        if ((read_char == 8) && (char_count >= 1))
                        {

                                if (in_char[char_count] == '.')
                                        char_count--;
                                if (in_char[char_count] == '-')
                                        minus_sg = 0;

                                poscurs(rd_row, (char_count + rd_col));
                                putchar(' ');
                                char_count--;
                        }
                        if (loop_count == 79)
                        {
                                in_char[rd_dig] = '\0';
                                break;
                        }
                        if (read_char == '-')
                        {
                                minus_sg = 1;
                        }
                }
/**/


/* scrlib.c functions for editing and screen control                   */
/* Copyright 1991 David R. Gregoire  all rights reserved               */


                val_code = 0;
                for (count = 0; count < rd_dig; count++)
                {
                        if (!(((in_char[count] >= '0') && (in_char[count] <= '9')) ||
                              (in_char[count] == ' ') ||
                              (in_char[count] == '.') ||
                              (in_char[count] == '-')))
                                val_code = 1;
                }
                poscurs(rd_row, (rd_col + rd_dig));

                if (val_code == 0)
                        putchar(' ');
                else
                        putchar('*');

        }
        /* end of edt_num   */
        strcpy(ed_num, in_char);/* return string */
}


/************************************************************/
/* reads an integer at rd_row, rd_col up to rd_dig long . No checking is done */
/* to make sure the intended number is returned.i.e. if too many digits are read */
/* the returned value may overflow an int */
/************************************************************/
int
read_int(int rd_row, int rd_col, int rd_dig)
{
        /* start of read number  */

        int             char_count = 0; /* character counter */
        char            in_char[20];
        int             loop_count;
        char            read_char;
        int             ret_num;
        int             minus_sg = 0;
        int             old_rd_dig;

        old_rd_dig = rd_dig;
        for (loop_count = 0; loop_count < 80; loop_count++)
        {


                if ((char_count == 0) && (rd_dig > old_rd_dig))
                        rd_dig = old_rd_dig;    /* reset digits if backspaced
                                                 * to zero with prev minus */

                if (char_count == 0)    /* reset allow minus sign if backspaced
                                         * to 0 */
/**/


/* scrlib.c functions for editing and screen control                   */
/* Copyright 1991 David R. Gregoire  all rights reserved               */


                        minus_sg = 0;
                if (char_count == 1)    /* allow minus sign in first character
                                         * only */
                        minus_sg = 1;

                poscurs(rd_row, (char_count + rd_col));
                read_char = getch();
                if (((read_char >= '0') && (read_char <= '9')) ||
                    ((read_char == '-') && (minus_sg == 0)))
                {

                        putchar(read_char);
                        in_char[char_count] = read_char;
                        char_count++;
                } else if (read_char == 13)
                {
                        in_char[char_count] = '\0';
                        break;
                }
                if (loop_count == 79)
                        in_char[char_count] = '\0';

                if ((read_char == 8) && (char_count >= 1))
                {
                        poscurs(rd_row, (char_count + rd_col));
                        putchar(' ');
                        in_char[char_count] = '\0';     /* if max key presses
                                                         * proper return */
                        char_count--;
                }
                if (read_char == '-')
                {
                        rd_dig++;       /* if negative allow one more digit to
                                         * be read */
                        minus_sg = 1;
                }
                if (char_count == rd_dig)
                {               /* check for max char count  */
                        in_char[char_count] = '\0';
                        break;
                }
        }
        ret_num = atoi(in_char);
        return (ret_num);
        /* end of read_int   */
}
/**/


/* scrlib.c functions for editing and screen control                   */
/* Copyright 1991 David R. Gregoire  all rights reserved               */


/***********************************************************************/
/*sub_str()  initializes a string pointed to by dest_str  with num_char */
/* characters from src_str starting at st_col , no checking is done on either*/
/*string i.e. you must be sure not to 'run off' the end of either string with */
/* subscripts outside the range of the defined strings */

/***********************************************************************/
void
sub_str(int st_col, int num_char, char *src_str, char *dest_str)
{
        int             ctr;

        for (ctr = 0; ctr < num_char; ctr++)
        {
                dest_str[ctr] = src_str[st_col + ctr];  /* move characters */
        }
        dest_str[ctr] = '\0';   /* string terminator */

}

/***********************************************************************/
/*rep_str()  replaces num_char characters in src_str with num_char characters */
/* from dest_str starting at st_col, no checking is done on either*/
/*string i.e. you must be sure not to 'run off' the end of either string with */
/* subscripts outside the range of the defined strings */

/***********************************************************************/

void
rep_str(int st_col, int num_char, char *src_str, char *dest_str)
{
        int             ctr;

        for (ctr = 0; ctr < num_char; ctr++)
        {
                src_str[st_col + ctr] = dest_str[ctr];  /* move characters */
        }

}

/***********************************************************************/
/*get_date() similar to sub_str(), gets an 8 character date of the form */
/* yyyymmdd from src_str starting at st_col. The date string is put into */
/* dest_str in the form dd/mm/yy, including the '/' characters  */
/* no checking is done on src_str or dest_str */
/***********************************************************************/

void
get_date(int st_col, char *src_str, char *dest_str)
{
        dest_str[0] = src_str[st_col + 4];
        dest_str[1] = src_str[st_col + 5];
        dest_str[2] = '/';
        dest_str[3] = src_str[st_col + 6];
        dest_str[4] = src_str[st_col + 7];
        dest_str[5] = '/';
        dest_str[6] = src_str[st_col + 2];
        dest_str[7] = src_str[st_col + 3];
        dest_str[8] = '\0';     /* string terminator */

}

/**/


/* scrlib.c functions for editing and screen control                   */
/* Copyright 1991 David R. Gregoire  all rights reserved               */


/***********************************************************************/
/*ret_date() similar to rep_str(), replaces an 8 character date of the form */
/* yyyymmdd to src_str starting at st_col. The date string is taken from */
/* dest_str in the form dd/mm/yy, including the '/' characters  */
/* no checking is done on either string */
/***********************************************************************/
void
ret_date(int st_col, char *src_str, char *dest_str)
{
    int       count = 0;
if (( dest_str[0] != ' ') && (dest_str[1] != ' '))
    {
        /* year 1st four positions */
        src_str[st_col] = '1';
        src_str[st_col + 1] = '9';
        src_str[st_col + 2] = dest_str[6];
        src_str[st_col + 3] = dest_str[7];
        /* month next 2 */
        src_str[st_col + 4] = dest_str[0];
        src_str[st_col + 5] = dest_str[1];
        /* day   last 2 */
        src_str[st_col + 6] = dest_str[3];
        src_str[st_col + 7] = dest_str[4];
     }
    else
    {
         for(count = 0;count<8;count++)
         src_str[st_col+ count] = dest_str[count];

    }
}

/*******************************************************************/
/* This function can be used in place of */
/* printf or puts to use direct memory access to write a string to the display */
/* at least on a slow machine this is dramatically faster than printf or puts */
/******************************************************************/
void
dir_str(int wr_row, int wr_col, char *dir_str)
{
        int far        *scrp;
        int             count = 0;

        scrp = (int far *) VID_START;

        while (dir_str[count])
        {

                *(scrp + wr_row * COMAX + wr_col + count) = dir_str[count] | ATT_NOR;
                count++;
        }
}

/**/


/* scrlib.c functions for editing and screen control                   */
/* Copyright 1991 David R. Gregoire  all rights reserved               */


/************************************************************************/
/* wi_rst1()  is used to restore a rectangular region of the screen from  an */
/* array of int, This function is the inverse of  */
/* wi_sav1(), it assumes that part of the screen was previously saved */
/* by wi_sav(), no checking is done on the array */
/* The only diffreence between this function and wi_rst() is that it uses */
/* a single dimension array */
/************************************************************************/
void
wi_rst1(int ulr, int ulc, int lrr, int lrc, int *sav)
{
        int             count;
        int             count1;
        int far        *scrp;


        scrp = (int far *) VID_START;

        for (count1 = (ulr); count1 < lrr + 1; count1++)
        {
                for (count = (ulc); count < lrc + 1; count++)
                {
                        *(scrp + count1 * COMAX + count) = *(sav + count1 * COMAX + count);
                }
        }

}
